/*
 ******************************************************************************

 LIBGPF: <sample> io target header

 Copyright (C) 2002 <Author>	[<you@there.com>]

 Permission is hereby granted, free of charge, to any person obtaining a
 copy of this software and associated documentation files (the "Software"),
 to deal in the Software without restriction, including without limitation
 the rights to use, copy, modify, merge, publish, distribute, sublicense,
 and/or sell copies of the Software, and to permit persons to whom the
 Software is furnished to do so, subject to the following conditions:

 The above copyright notice and this permission notice shall be included in
 all copies or substantial portions of the Software.

 THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.  IN NO EVENT SHALL
 THE AUTHOR(S) BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER
 IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN
 CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.

 ******************************************************************************
 */

#include <ggi/internal/gpf.h>
#include <ggi/internal/gpf_debug.h>
#include <ggi/internal/gpf_helpers.h>

#include <string.h>


/*
 *      "exported" Function prototypes
 */

GPFio_open			GPF_<sample>_open;
GPFio_close			GPF_<sample>_close;

GPFio_timestamp			GPF_<sample>_timestamp;

GPFio_read			GPF_<sample>_read;
GPFio_write			GPF_<sample>_write;


GPFpipe_setup			GPF_<sample>_setup_input;
GPFpipe_setup			GPF_<sample>_setup_output;
GPFpipe_TransferNextStreamBlock	GPF_<sample>_transfernextstreamblock_input;
GPFpipe_TransferNextStreamBlock	GPF_<sample>_transfernextstreamblock_output;
GPFpipe_getformat		GPF_<sample>_getformat;
GPFio_pipe_getinfolist		GPF_<sample>_pipe_getinfolist;


struct <sample>gpf_priv;


/* Put in your target specific conversion stuff here
 * The stuff below is only example
 * If no conversion can be done by the target at all,
 * then you may remove that.
 */


typedef ssize_t (<sample>_conv)(struct <sample>gpf_priv *priv,
                        void *buf_in, void *buf_out,
                        size_t size_in, size_t size_out);


<sample>_conv                        GPF_<sample>_conv_<func1>;
<sample>_conv                        GPF_<sample>_conv_<func2>;




/* Structure holding private data.
 */
struct <sample>gpf_priv {
	uint32 nr;
	uint32 doconv;
	<sample>_conv	*func_conv;

	/* Put in your target specific stuff */
};

#define <sample>_PRIV(io)		\
		((struct <sample>gpf_priv *)(LIBGPF_IO_PRIVATE(io)))
